import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import java.awt.*;

public abstract class Botonera
{
	private ControlUnit controlUnit;
	private int location;
	protected JLabel floorIndication;

	public Botonera(ControlUnit cu, int location)
	{
		controlUnit = cu;
		this.location = location; // 0 means in cabina

		floorIndication = new JLabel("1");
		floorIndication.setHorizontalAlignment(JLabel.CENTER);
		floorIndication.setFont(new Font("Serif", Font.PLAIN, 40));
	}
	public int getLocation()
	{
		return location;
	}
	protected void elevatorRequested()
	{
		controlUnit.elevatorRequested(location);
	}
	protected void elevatorRequested(int destination)
	{
		controlUnit.elevatorRequested(destination);
	}
	public void updateFloorIndication(int floor)
	{
		floorIndication.setText(Integer.toString(floor));
	}

	public abstract void setBotonNewDimension(int xy);		// In case the buttons need size adjustments
	public abstract JComponent getView();
}