import javax.swing.*;
import java.awt.event.*;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

public class Boton implements ActionListener
{
	public Boton (ImageIcon imageOff, ImageIcon imageOn, Botonera b)
	{
		state = false;
		imgOff = imageOff;
		imgOn = imageOn;
		view = new JButton(imgOff);

		int imgX, imgY;
		imgX = imgOff.getIconWidth();
		imgY = imgOff.getIconHeight();
		view.setPreferredSize(new Dimension(imgX,imgY));
		
		view.addActionListener(this);
		botonera = b;
	}
	public JButton getView()
	{
		return view;
	}
	public void turnON()
	{
		state = true;
		view.setIcon(imgOn);		// I think so
	}
	public void turnOFF()
	{
		state = false;
		view.setIcon(imgOff);
	}
	public void setNewDimension(int xy)
	{
		if(xy < imgOff.getIconHeight() && xy < imgOff.getIconHeight())
		{
			Image aux = imgOff.getImage();
			BufferedImage bi = new BufferedImage(xy, xy, BufferedImage.TRANSLUCENT);
			Graphics g = bi.createGraphics();
			g.drawImage(aux, 0, 0, xy, xy, null);
			ImageIcon newIcon = new ImageIcon(bi);
			g.dispose();
			imgOff = newIcon;

			aux = imgOn.getImage();
			BufferedImage bi2 = new BufferedImage(xy, xy, BufferedImage.TRANSLUCENT);
			Graphics g2 = bi2.createGraphics();
			g2.drawImage(aux, 0, 0, xy, xy, null);
			ImageIcon newIcon2 = new ImageIcon(bi2);
			g.dispose();
			imgOn = newIcon2;

			view.setIcon(imgOff);

			int imgX = imgOff.getIconWidth();
			int imgY = imgOff.getIconHeight();
			view.setPreferredSize(new Dimension(imgX,imgY));
		}
	}
	public boolean isOn()
	{
		return state;
	}
	public boolean getState()
	{
		return state;
	}
	public String toString()
	{
		return state?"1":"0";
	}
	public void actionPerformed (ActionEvent event)
	{
		turnON();
		if(botonera instanceof BotoneraCabina)
			botonera.elevatorRequestedCabina();	// it can't be location
		else
			botonera.elevatorRequested(botonera.getLocation());
	}
	public int getBtnPreferredSize()
	{
		return imgOff.getIconWidth();
	}

/*	public void setBtnPreferredSize()
	{
		int imgX, imgY;
		imgX = imgOff.getIconWidth();
		imgY = imgOff.getIconHeight();
		view.setPreferredSize(new Dimension(imgX,imgY));
	}*/

	private boolean state;
	private Botonera botonera; // to let botonera know the new request.
	private ImageIcon imgOff, imgOn;
	private JButton view;
}