import java.util.ArrayList;
import javax.swing.*;
import javax.swing.JComponent;
import java.util.Scanner;
import java.awt.Font;
import java.awt.Component;
import java.awt.BorderLayout;
import java.awt.Dimension;

public class BotoneraCabina extends Botonera
{
	private Boton[] botones;
	private JPanel view;
	private JLabel floorIndicator;
	private Cabina cabina;

	public BotoneraCabina(int n_pisos, ControlUnit cu, int location)
	{
		super(cu, location);
		view = new JPanel();

		view.setLayout(new BoxLayout(view,BoxLayout.Y_AXIS));
				
		floorIndicator = new JLabel("1");
		floorIndicator.setAlignmentX(Component.CENTER_ALIGNMENT);
		floorIndicator.setFont(new Font("Serif", Font.PLAIN, 40));
		//floorIndicator.setPreferredSize(new Dimension(100, 100));

		view.add(floorIndicator);

		botones = new Boton[n_pisos];
		setBotones(n_pisos);
		for (int i = 0; i < botones.length; i++){
			botones[i].setNewDimension(50);
			botones[i].getView().setAlignmentX(Component.CENTER_ALIGNMENT);
		}
	}

	private void setBotones(int n_pisos)
	{
		for(int i = n_pisos; i > 0; i--)
		{
            botones[i-1] = new Boton(new ImageIcon(String.format("%d_Off.png",i)), new ImageIcon(String.format("%d_On.png",i)), this);
            view.add(botones[(i-1)].getView());
			//botones[i-1].setBtnPreferredSize();
        }
	}
	public Boton getBoton(int i)
	{
		return botones[i];
	}

	public int searchBtnON()
	{
		for(int i = 0; i < botones.length; i++)
			if (botones[i].isOn())
				return i+1;
		return 0;
	}

	public void setCabina(Cabina c)
	{
		cabina = c;
	}
	public void setFloorIndicator(int cabinFloor)
	{
		floorIndicator.setText(Integer.toString(cabinFloor));
	}
	public JPanel getView()
	{
		 return view;
	}
	public void setBotonNewDimension(int xy)		// In case the buttons need size adjustments
	{
		for (int i=0; i < botones.length; i++) 
			botones[i].setNewDimension(xy);
	}

	public void resetFloorRequest(int i)
	{
		botones[i-1].turnOFF();
	}
	public boolean isFloorRequested(int i)
	{
		return botones[i-1].getState();
	}
	public String toString()
	{
		String s="";
		for(Boton b: botones)
			s+=b.toString();
		return s;
	}
}