import javax.swing.*;
import java.awt.*;

public class BotoneraPisoIntermedio extends Botonera implements DownRequest, UpRequest
{
	private Boton up, down;
	private BotoneraPisoIntermedioView view;
	public BotoneraPisoIntermedio (ControlUnit cu, int location)
	{
		super (cu, location);
		up = new Boton(new ImageIcon("upOff.png"), new ImageIcon("upOn.png"), this);
		down = new Boton(new ImageIcon("downOff.png"), new ImageIcon("downOn.png"), this);
		view = new BotoneraPisoIntermedioView();
	}
	public void setBotonNewDimension(int xy)
	{
		up.setNewDimension(xy);
		down.setNewDimension(xy);
	}
	public JPanel getView()
	{
		return view;
	}	

	// UpRequest interface implementation
	public void resetUpRequest()
	{
		up.turnOFF();
	}
	public boolean isUpRequested()
	{
		return up.getState();
	}

	// DownResquest interface implementation
	public void resetDownRequest()
	{
		down.turnOFF();
	}
	public boolean isDownRequested()
	{
		return down.getState();
	}
	class BotoneraPisoIntermedioView extends JPanel
	{
		BotoneraPisoIntermedioView()
		{
			super(new GridBagLayout());
			GridBagConstraints c = new GridBagConstraints();

			c.fill = GridBagConstraints.HORIZONTAL;
			c.weightx = 0.5;
			c.gridx = 0;
			c.gridy = 0;
			c.gridwidth = 2;
			add(floorIndicator, c);

			c.fill = GridBagConstraints.HORIZONTAL;
			c.weightx = 0.5;
			c.gridx = 0;
			c.gridy = 1;
			c.gridwidth = 1;
			add(up.getView(), c);

			c.fill = GridBagConstraints.HORIZONTAL;
			c.weightx = 0.5;
			c.gridx = 1;
			c.gridy = 1;
			add(down.getView(), c);

			/*super(new BorderLayout());
			add(floorIndication,BorderLayout.PAGE_START);
			//	to be coded by you
			add(up.getView(), BorderLayout.EAST);
			add(down.getView(), BorderLayout.WEST);*/
		}
	}
}
