import javax.swing.*;
import java.awt.*;

/**
 * Clase que implementa el output visual de la botonera de cabina.
 *
 * @version 0.4
 */
public class BotoneraCabinaView
{
    //#################################
    private JPanel view;
    private JLabel floorindicator;

    //#################################

    /**
     * Constructor publico.
     * Inicializa el objeto JPanel y agrega el indicador de piso.
     *
     * @param f_label       Numero de piso.
     */
    public BotoneraCabinaView(int f_label)
    {
        view = new JPanel();
        view.setLayout(new BoxLayout(view,BoxLayout.Y_AXIS));
        floorindicator = new JLabel(Integer.toString(f_label));
        floorindicator.setAlignmentX(Component.CENTER_ALIGNMENT);
        floorindicator.setFont(new Font("Serif", Font.PLAIN, 40));
        floorindicator.setPreferredSize(new Dimension(100, 100));
        view.add(floorindicator);
    }

    //#################################

    /**
     * Metodo que permite modificar el valor del indicador de piso.
     * @param f_label       Numero de piso.
     */
    public void setFloorIndicator(int f_label)
    {
        floorindicator.setText(Integer.toString(f_label));
    }

    /**
     * Metodo que permite agregar un boton en el panel.
     * @see Boton
     * @param new_button    Objeto de boton.
     */
    public void addButton(Boton new_button)
    {
        view.add(new_button.getView());
    }

    /**
     * Metodo que retorna el panel que incluye el indicador y botones.
     * @return      Objeto de panel.
     */
    public JPanel getView()
    {
        return view;
    }
}
