import java.awt.*;
import java.awt.geom.Rectangle2D;

public class CabinaView extends Rectangle2D.Double
{
    //#################################
    private double xpos, width, height;
    private CajaAscensorView shaftview;
    private Container container;

    //#################################
    public CabinaView(double x, double pos, double w, double h)
    {
        container = null;
        xpos = x;
        width = w;
        height = h;
        setPosition(pos);
    }

    //#################################
    public void setPosition(double pos)
    {
        setFrame(xpos, pos, width, height);
        if(container != null)
            shaftview.repaint();
    }
    public void setContainer(Container cont, int index)
    {
        container = cont;
        shaftview = (CajaAscensorView) container.getComponent(index-1);
    }
    public void draw(Graphics2D graph)
    {
        graph.setColor(new Color(138, 239, 148));
        graph.fill(this);
        graph.setColor(Color.BLACK);
        graph.draw(this);
    }
}
