import java.awt.*;
import java.awt.geom.Rectangle2D;

public class LightView extends Rectangle2D.Double
{
    //#################################
    private double xpos, width, height;
    private CajaAscensorView shaftview;
    private Container container;
    private Color color;
    private boolean light_on;

    //#################################
    public LightView(double x, double pos, double w, double h)
    {
        container = null;
        width = w/4;
        height = h/8;
        xpos = x+(w/2)-(width/2);
        setPosition(pos+h);//+(h));
        light_on = false;
    }

    //#################################
    public void setPosition(double pos)
    {
        setFrame(xpos, pos+(height*8)-height, width, height);
        if(container != null)
            shaftview.repaint();
    }
    public void setContainer(Container cont, int index)
    {
        container = cont;
        shaftview = (CajaAscensorView) container.getComponent(index-1);
    }
    public void turnOnLight()
    {
        light_on = true;
    }
    public void turnOffLight()
    {
        light_on = false;
    }
    public void draw(Graphics2D graph)
    {
        if(light_on)
        {
            graph.setColor(Color.YELLOW);
            graph.fill(this);
        }        
        graph.setColor(Color.BLACK);
        graph.draw(this);
    }
}
